Index: /trunk/src/org/expeditee/items/widgets/HeavyDutyInteractiveWidget.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/HeavyDutyInteractiveWidget.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/HeavyDutyInteractiveWidget.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.items.widgets;
 
-import java.awt.Color;
 import java.awt.Font;
 import java.awt.FontMetrics;
@@ -33,7 +32,10 @@
 import javax.swing.SwingUtilities;
 
+import org.expeditee.core.Colour;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingGraphicsManager;
+import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FreeItems;
 import org.expeditee.items.Item;
@@ -53,5 +55,5 @@
  * until expeditee allocates a thread to begin loading. The swing component is set as not-visible.
  * 
- * At the the loading stage, a loadable widget proccesses its load task and renders a
+ * At the the loading stage, a loadable widget processes its load task and renders a
  * load message/bar.
  * 
@@ -59,11 +61,11 @@
  * 
  * When a HeavyDutyInteractiveWidget becomes visible / is anchored, it will register itself for saving at the next
- * save point according to SaveEntityManager. Heavey duty widgets will only save at the save points 
+ * save point according to SaveEntityManager. Heavy duty widgets will only save at the save points 
  * if the widget still belongs to a frame (i.e. is not removed) and is anchored.
  * 
- * Heavey duty widgets can also have an expiry on how long they should stay cached for. If they do have an 
+ * Heavy duty widgets can also have an expiry on how long they should stay cached for. If they do have an 
  * expiry then it they unload once expired, and will re-load once in view again. Must take care for
  * unloadable widgets because you must check your unloadable elements to whether they are unloaded or not
- * every time your widget accessess them.
+ * every time your widget accesses them.
  * 
  * When a heavy duty widget is deleted - any data consuming memory can be dumped temporarily if needed.
@@ -72,5 +74,5 @@
  *
  */
-public abstract class HeavyDutyInteractiveWidget extends InteractiveWidget implements LoadableEntity, SaveableEntity {
+public abstract class HeavyDutyInteractiveWidget extends SwingWidget implements LoadableEntity, SaveableEntity {
 	
 	/** load finished */
@@ -90,9 +92,9 @@
 	private static final String PENDING_MESSAGE = "Pending";
 	
-	private static final Color LOAD_BAR_PROGRESS_COLOR = new Color(103, 171, 203);
-	private static final Color LOAD_BAR_INDETERM_COLOR = Color.ORANGE;
-	private static final Color LOAD_BAR_HIGHLIGHT_COLOR = new Color(240, 240, 240);
-	private static final Color LOAD_SCREEN_COLOR = Color.LIGHT_GRAY;
-	private static final Color LOAD_SCREEN_COLOR_FREESPACE = FREESPACE_BACKCOLOR;
+	private static final Colour LOAD_BAR_PROGRESS_COLOR = Colour.FromRGB255(103, 171, 203);
+	private static final Colour LOAD_BAR_INDETERM_COLOR = Colour.ORANGE;
+	private static final Colour LOAD_BAR_HIGHLIGHT_COLOR = Colour.FromRGB255(240, 240, 240);
+	private static final Colour LOAD_SCREEN_COLOR = Colour.LIGHT_GREY;
+	private static final Colour LOAD_SCREEN_COLOR_FREESPACE = FREESPACE_BACKCOLOR;
 	
 	private static final Font LOAD_NORMAL_FONT = new Font("Arial", Font.BOLD, 12);
@@ -140,5 +142,6 @@
 	 */
 	protected HeavyDutyInteractiveWidget(Text source, JComponent component,
-			int minWidth, int maxWidth, int minHeight, int maxHeight, int cacheDepth, boolean skipLoad) {
+			int minWidth, int maxWidth, int minHeight, int maxHeight, int cacheDepth, boolean skipLoad)
+	{
 		super(source, component, minWidth, maxWidth, minHeight, maxHeight);
 		
@@ -173,5 +176,5 @@
 	 * 
 	 * @param percent 
-	 * 		Must be between 0.0 and 1.0 inclusive for percentage. Or neagtive if indeterminant.
+	 * 		Must be between 0.0 and 1.0 inclusive for percentage. Or negative if indeterminate.
 	 * 
 	 * @throws IllegalArgumentException
@@ -182,5 +185,6 @@
 	 * 		
 	 */
-	protected final void updateLoadPercentage(float percent) {
+	protected final void updateLoadPercentage(float percent)
+	{
 		if (percent > 1.0f) 
 			throw new IllegalArgumentException("loadState is larger than 1.0");
@@ -199,5 +203,6 @@
 	 * @return The current load state.
 	 */
-	protected float getLoadState() {
+	protected float getLoadState()
+	{
 		return loadState;
 	}
@@ -206,5 +211,6 @@
 	 * @return True if in a loading phase.
 	 */
-	protected boolean isInLoadProgress() {
+	protected boolean isInLoadProgress()
+	{
 		return loadState <= 1.0f;
 	}
@@ -226,36 +232,45 @@
 		
 		// Re-render loading state
-		FrameGraphics.invalidateArea(_swingComponent.getBounds());
-		FrameGraphics.requestRefresh(true);
+		DisplayController.invalidateArea(getBounds());
+		DisplayController.requestRefresh(true);
 	}
 	
 	@Override
-	public void paintInFreeSpace(Graphics g) {
-		if (loadState == LOAD_STATE_COMPLETED) super.paintInFreeSpace(g);
-		else paintLoadScreen(g, LOAD_SCREEN_COLOR_FREESPACE);
+	public void paintInFreeSpace() {
+		if (loadState == LOAD_STATE_COMPLETED) super.paintInFreeSpace();
+		else paintLoadScreen(LOAD_SCREEN_COLOR_FREESPACE);
 	}
 
 	@Override
-	public void paint(Graphics g) {
+	protected final void paintSwingWidget(Graphics2D g)
+	{
 		if (loadState == LOAD_STATE_COMPLETED) {
-			super.paint(g);
+			paintHeavyDutyWidget(g);
 		} else {
-			paintLoadScreen(g, LOAD_SCREEN_COLOR);
-			this.paintLink((Graphics2D)g);
-		}
-		
-	}
-	
-	/**
-	 * Rendersthe load bar / load messages
+			paintLoadScreen(LOAD_SCREEN_COLOR);
+		}
+		
+	}
+	
+	/** Can be overridden to provide custom drawing. */
+	protected void paintHeavyDutyWidget(Graphics2D g)
+	{
+		super.paintSwingWidget(g);
+	}
+	
+	/**
+	 * Renders the load bar / load messages
 	 * 
 	 * @param g
 	 */
-	private void paintLoadScreen(Graphics g, Color backgroundColor) {
+	private void paintLoadScreen(Colour backgroundColor) {
 
 		if (Browser._theBrowser == null) return;
 		
+		SwingGraphicsManager manager = SwingMiscManager.getIfUsingSwingGraphicsManager();
+		Graphics g = manager.getCurrentSurface();
+		
 		// Render shaded window over widget
-		g.setColor(backgroundColor);
+		g.setColor(SwingConversions.toSwingColor(backgroundColor));
 		g.fillRect(getX(), getY(), getWidth(), getHeight());
 		
@@ -291,8 +306,8 @@
 		Rectangle tmpClip = (clipBackUp != null) ? clipBackUp.getBounds() : 
 			new Rectangle(0, 0, 
-					Browser._theBrowser.getContentPane().getWidth(), 
-					Browser._theBrowser.getContentPane().getHeight());
-			
-		g.setClip(tmpClip.intersection(getBounds()));
+					manager.getContentPane().getWidth(), 
+					manager.getContentPane().getHeight());
+			
+		g.setClip(tmpClip.intersection(SwingConversions.toSwingRectangle(getBounds())));
 	
 		
@@ -300,6 +315,6 @@
 
 			GradientPaint gp = new GradientPaint(
-					0, barY + (int)(BAR_HEIGHT * 0.8), LOAD_BAR_INDETERM_COLOR,
-					0, barY, LOAD_BAR_HIGHLIGHT_COLOR);
+					0, barY + (int)(BAR_HEIGHT * 0.8), SwingConversions.toSwingColor(LOAD_BAR_INDETERM_COLOR),
+					0, barY, SwingConversions.toSwingColor(LOAD_BAR_HIGHLIGHT_COLOR));
 			((Graphics2D)g).setPaint(gp);
 		
@@ -311,6 +326,6 @@
 			
 			GradientPaint gp = new GradientPaint(
-					0, barY + (int)(BAR_HEIGHT * 0.8), LOAD_BAR_PROGRESS_COLOR,
-					0, barY, LOAD_BAR_HIGHLIGHT_COLOR);
+					0, barY + (int)(BAR_HEIGHT * 0.8), SwingConversions.toSwingColor(LOAD_BAR_PROGRESS_COLOR),
+					0, barY, SwingConversions.toSwingColor(LOAD_BAR_HIGHLIGHT_COLOR));
 			((Graphics2D)g).setPaint(gp);
 			
@@ -319,11 +334,11 @@
 		} 
 		
-		g.setColor(Color.DARK_GRAY);
+		g.setColor(SwingConversions.toSwingColor(Colour.DARK_GREY));
 		g.drawRect(barX, barY, barWidth, BAR_HEIGHT);
 		
 		if (loadState == LOAD_STATE_FAILED) 
-			g.setColor(Color.RED);
-		
-		else g.setColor(Color.BLACK);
+			g.setColor(SwingConversions.toSwingColor(Colour.RED));
+		
+		else g.setColor(SwingConversions.toSwingColor(Colour.BLACK));
 		
 
@@ -638,6 +653,6 @@
 			// Re-render loading state - if not expired
 			if (!expired) {
-				FrameGraphics.invalidateArea(new Rectangle(getX(), getY(), getWidth(), getHeight()));
-				FrameGraphics.requestRefresh(true);
+				DisplayController.invalidateArea(getBounds());
+				DisplayController.requestRefresh(true);
 			}
 		}
@@ -680,5 +695,5 @@
 			
 			// Only load if in view
-			if (!isFloating() && getParentFrame() != DisplayIO.getCurrentFrame())
+			if (!isFloating() && getParentFrame() != DisplayController.getCurrentFrame())
 				return;
 			
Index: /trunk/src/org/expeditee/items/widgets/JSWidget.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/JSWidget.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/JSWidget.java	(revision 1102)
@@ -32,5 +32,5 @@
 import javax.swing.JPanel;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.JSThreadable;
@@ -75,6 +75,6 @@
     
 	private static Text getSauce() {
-		Text source = new Text(DisplayIO.getCurrentFrame().getNextItemID(), "@iw: org.expeditee.items.widgets.JSWidget");
-		source.setParent(DisplayIO.getCurrentFrame());
+		Text source = new Text(DisplayController.getCurrentFrame().getNextItemID(), "@iw: org.expeditee.items.widgets.JSWidget");
+		source.setParent(DisplayController.getCurrentFrame());
 		return source;
 	}
@@ -172,5 +172,5 @@
     
     @Override
-	protected void paintLink(Graphics2D g) {
+	protected void paintLink() {
     	return;
 	}
Index: /trunk/src/org/expeditee/items/widgets/JfxBrowser.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/JfxBrowser.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/JfxBrowser.java	(revision 1102)
@@ -76,6 +76,7 @@
 import netscape.javascript.JSObject;
 
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.FrameMouseActions;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FreeItems;
 import org.expeditee.gui.MessageBay;
@@ -468,5 +469,5 @@
 				public void handle(KeyEvent e) {
 					// Hiding the cursor when typing, to be more Expeditee-like
-					DisplayIO.setCursor(org.expeditee.items.Item.HIDDEN_CURSOR);
+					DisplayController.setCursor(org.expeditee.items.Item.HIDDEN_CURSOR);
 				}
 			});
@@ -481,7 +482,7 @@
 					}
 					// Checking if the user has been typing - if so, move the cursor to the caret position
-					if (DisplayIO.getCursor() == Item.HIDDEN_CURSOR) {
-						DisplayIO.setCursor(org.expeditee.items.Item.TEXT_CURSOR);
-						DisplayIO.setCursorPosition(getCoordFromCaret(JfxBrowser.this._urlField));
+					if (DisplayController.getCursor() == Item.HIDDEN_CURSOR) {
+						DisplayController.setCursor(org.expeditee.items.Item.TEXT_CURSOR);
+						DisplayController.setCursorPosition(SwingConversions.fromSwingPoint(getCoordFromCaret(JfxBrowser.this._urlField)));
 					} else {
 						// Otherwise, move the caret to the cursor location
@@ -523,8 +524,8 @@
                 public void changed(ObservableValue<? extends Boolean> property, Boolean oldValue, Boolean newValue) {
 					if(newValue.booleanValue()) {
-						DisplayIO.setCursor(org.expeditee.items.Item.TEXT_CURSOR);
+						DisplayController.setCursor(org.expeditee.items.Item.TEXT_CURSOR);
 					} else {
 						// Restoring the standard cursor, since it is changed to a text cursor when focus is gained
-						DisplayIO.setCursor(org.expeditee.items.Item.DEFAULT_CURSOR);
+						DisplayController.setCursor(org.expeditee.items.Item.DEFAULT_CURSOR);
 					}
                 }
@@ -545,9 +546,9 @@
 					if (e.getButton() == MouseButton.SECONDARY) {
 						// Right mouse button released, so copy the selection (i.e. don't remove the original)
-						item = DisplayIO.getCurrentFrame().createNewText(JfxBrowser.this._urlField.getSelectedText());
-						FrameMouseActions.pickup(item);
+						item = DisplayController.getCurrentFrame().createNewText(JfxBrowser.this._urlField.getSelectedText());
+						StandardGestureActions.pickup(item);
 					} else if (e.getButton() == MouseButton.MIDDLE) {
 						// Middle mouse button released, so copy the selection then remove it from the URL field
-						item = DisplayIO.getCurrentFrame().createNewText(JfxBrowser.this._urlField.getSelectedText());
+						item = DisplayController.getCurrentFrame().createNewText(JfxBrowser.this._urlField.getSelectedText());
 						JfxBrowser.this._urlField.setText(
 								JfxBrowser.this._urlField.getText().substring(0, JfxBrowser.this._urlField.getSelection().getStart())
@@ -555,5 +556,5 @@
 										JfxBrowser.this._urlField.getText().length()));
 
-						FrameMouseActions.pickup(item);
+						StandardGestureActions.pickup(item);
 					}
                 }
@@ -660,6 +661,6 @@
     									
     									if (((String) style.call("getPropertyValue", new Object[] { "background-image" })).startsWith("url(")) {
-    										pic = WebParser.getBackgroundImageFromNode(node, style, DisplayIO.getCurrentFrame(), null,
-    											(float) FrameMouseActions.getX(), (float) FrameMouseActions.getY(), width, height);
+    										pic = WebParser.getBackgroundImageFromNode(node, style, DisplayController.getCurrentFrame(), null,
+    											(float) DisplayController.getMouseX(), (float) DisplayController.getMouseY(), width, height);
     										
     									} else {
@@ -667,6 +668,6 @@
     										if(node.getNodeName().toLowerCase().equals("img") && 
     												(imgSrc = ((JSObject) node).getMember("src").toString()) != null) {
-    											pic = WebParser.getImageFromUrl(imgSrc, null, DisplayIO.getCurrentFrame(),
-    													(float) FrameMouseActions.getX(), (float) FrameMouseActions.getY(), (int) width, null, null, null, null, null, 0, 0);
+    											pic = WebParser.getImageFromUrl(imgSrc, null, DisplayController.getCurrentFrame(),
+    													(float) DisplayController.getMouseX(), (float) DisplayController.getMouseY(), (int) width, null, null, null, null, null, 0, 0);
     										} else {
     											return;
@@ -685,6 +686,6 @@
     									}
     									
-    									pic.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());
-                                		FrameMouseActions.pickup(pic);
+    									pic.setXY(DisplayController.getMouseX(), DisplayController.getMouseY());
+                                		StandardGestureActions.pickup(pic);
                             		} catch (Exception e1) {
     	                                // TODO Auto-generated catch block
@@ -714,23 +715,23 @@
 											+ ((JSObject)node).getMember("height")
 											+ ":" + src);
-									t.setParent(DisplayIO.getCurrentFrame());
-									t.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());
+									t.setParent(DisplayController.getCurrentFrame());
+									t.setXY(DisplayController.getMouseX(), DisplayController.getMouseY());
 									JfxMedia media = new JfxMedia(t, new String[] { src });
-									FrameMouseActions.pickup(media.getItems());
+									StandardGestureActions.pickup(media.getItems());
 									
 								} else if(node.getNodeName().toLowerCase().equals("a") && ((JSObject)node).getMember("href") != null) {
 									// If a link is right clicked, copy the text content and give it an action to create 
 									// a new frame containing a browser pointing to the linked page
-									Text t = DisplayIO.getCurrentFrame().createNewText(((String) ((JSObject)node).getMember("textContent")).trim());
+									Text t = DisplayController.getCurrentFrame().createNewText(((String) ((JSObject)node).getMember("textContent")).trim());
 									t.addAction("createFrameWithBrowser " + (String) ((JSObject)node).getMember("href"));
-									t.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());
-									FrameMouseActions.pickup(t);
+									t.setXY(DisplayController.getMouseX(), DisplayController.getMouseY());
+									StandardGestureActions.pickup(t);
 								}
 							}
 						} else {
 							// Copy text and attach to cursor
-							Text t = DisplayIO.getCurrentFrame().createNewText(selection);
-							t.setXY(FrameMouseActions.getX(), FrameMouseActions.getY());
-							FrameMouseActions.pickup(t);
+							Text t = DisplayController.getCurrentFrame().createNewText(selection);
+							t.setXY(DisplayController.getMouseX(), DisplayController.getMouseY());
+							StandardGestureActions.pickup(t);
 						}
 					}
@@ -871,5 +872,5 @@
 	public void getFrame() {
 		try {
-			WebParser.parsePageSimple(this, _webEngine, _webView, DisplayIO.getCurrentFrame());
+			WebParser.parsePageSimple(this, _webEngine, _webView, DisplayController.getCurrentFrame());
 		} catch (Exception e) {
 			e.printStackTrace();
@@ -886,5 +887,5 @@
 			new Thread(new Runnable() {
 				public void run() {
-					WebParser.parsePageSimple(JfxBrowser.this, JfxBrowser.this._webEngine, JfxBrowser.this._webView, DisplayIO.getCurrentFrame());
+					WebParser.parsePageSimple(JfxBrowser.this, JfxBrowser.this._webEngine, JfxBrowser.this._webView, DisplayController.getCurrentFrame());
 				}
 			}).start();
@@ -954,5 +955,5 @@
 		}
 
-		final int x = FrameMouseActions.getX() - this.getX(), y = FrameMouseActions.getY() - this.getY();
+		final int x = DisplayController.getMouseX() - this.getX(), y = DisplayController.getMouseY() - this.getY();
 		if(!this._urlField.getBoundsInParent().contains(x, y)) {
 			// fails if not clicking on urlField
Index: /trunk/src/org/expeditee/items/widgets/MemoryMonitor.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/MemoryMonitor.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/MemoryMonitor.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.items.widgets;
 
-import java.awt.Color;
 import java.awt.Font;
 import java.awt.Graphics;
@@ -27,4 +26,7 @@
 import javax.swing.SwingUtilities;
 
+import org.expeditee.core.Colour;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.Text;
@@ -36,5 +38,5 @@
  *
  */
-public class MemoryMonitor extends InteractiveWidget {
+public class MemoryMonitor extends SwingWidget {
 	
 	private long totalMemoryInBytes;
@@ -63,6 +65,6 @@
 	
 	@Override
-	public void paint(Graphics g) {
-		
+	public void paintSwingWidget(Graphics2D g)
+	{
 		int height = getHeight();
 		int width = getWidth();
@@ -70,26 +72,24 @@
 		int memHeight = (int)(height * currentMemoryUsage);
 		
-		Color memColor;
+		Colour memColor;
 		if (currentMemoryUsage > 0.8f) {
-			memColor = Color.RED;
+			memColor = Colour.RED;
 		} else if (currentMemoryUsage > 0.5f) {
-			memColor = Color.ORANGE;
+			memColor = Colour.ORANGE;
 		} else  {
-			memColor = Color.GREEN;
+			memColor = Colour.GREEN;
 		}
 		
-		g.setColor(memColor);
+		g.setColor(SwingConversions.toSwingColor(memColor));
 		g.fillRect(getX(), getY() + height - memHeight, width, memHeight);
 		
-		g.setColor(Color.WHITE);
+		g.setColor(SwingConversions.toSwingColor(Colour.WHITE));
 		g.fillRect(getX(), getY(), width, height - memHeight);
 		
 		int percent = (int)(currentMemoryUsage * 100.0f);
 		
-		g.setColor(Color.BLACK);
+		g.setColor(SwingConversions.toSwingColor(Colour.BLACK));
 		g.setFont(USAGE_FONT);
 		g.drawString(percent + "%", getX() + 12, getY() + (height / 2) + 8);
-		
-		paintLink((Graphics2D)g);
 	}
 
Index: /trunk/src/org/expeditee/items/widgets/Password.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/Password.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/Password.java	(revision 1102)
@@ -32,5 +32,5 @@
  * @author jts21
  */
-public class Password extends InteractiveWidget {
+public class Password extends SwingWidget {
 
 	private JPasswordField passwordField;
Index: /trunk/src/org/expeditee/items/widgets/RefreshButton.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/RefreshButton.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/RefreshButton.java	(revision 1102)
@@ -4,5 +4,5 @@
 import java.awt.event.ActionListener;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -20,10 +20,10 @@
 	        public void actionPerformed(ActionEvent e) {	        	
 	         
-	           Frame f = DisplayIO.getCurrentFrame();	  
+	           Frame f = DisplayController.getCurrentFrame();	  
 	           try{
 	        	   FrameIO.ForceSaveFrame(f);
 	        	   Frame g = FrameIO.LoadRestoreFrame(f);	
-	        	   DisplayIO.setCurrentFrame(g, false);
-		           FrameGraphics.refresh(true);
+	        	   DisplayController.setCurrentFrame(g, false);
+		           DisplayController.requestRefresh(true);
 	           }
 	           catch(Exception e1){
Index: /trunk/src/org/expeditee/items/widgets/RubbishBin.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/RubbishBin.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/RubbishBin.java	(revision 1102)
@@ -4,57 +4,69 @@
 import java.awt.event.ActionListener;
 
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.FrameMouseActions;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FreeItems;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
 
-//When the Rubbish Bin Widget is clicked by any of the mouse buttons, whatever is currently being picked up by the mouse is destroyed
-public class RubbishBin extends ButtonWidget{	
-		
-	public RubbishBin(Text source, String[] args){	
-					
+/**
+ * When the Rubbish Bin Widget is clicked by any of the mouse buttons,
+ * whatever is currently being picked up by the mouse is destroyed.
+ * 
+ * @author cts16
+ */
+public class RubbishBin extends ButtonWidget
+{	
+	public RubbishBin(Text source, String[] args)
+	{
 		super(80, "org/expeditee/assets/images/bin.svg", source, args);
 
-		clicked_.addActionListener(new ActionListener() {
-	        public void actionPerformed(ActionEvent e) {	
+		clicked_.addActionListener(new ActionListener()
+		{
+	        public void actionPerformed(ActionEvent e)
+	        {	
 	        	
 	        }          
-	     });		
+		});		
 	}
-	public boolean ItemsLeftClickDropped() {
-		
+	
+	public boolean ItemsLeftClickDropped()
+	{
 		//Find what the mouse was holding at the time and delete it
 		Item freeItems = FreeItems.getItemAttachedToCursor();
-		if( freeItems != null){
-			freeItems.setParent(DisplayIO.getCurrentFrame());
+		
+		if( freeItems != null) {
+			freeItems.setParent(DisplayController.getCurrentFrame());
 			
-			try{
-			
-			FrameMouseActions.delete(freeItems);		
-			}
-			catch(Exception e){
-				
+			try {
+				StandardGestureActions.delete(freeItems, null, null, false);		
+			} catch(Exception e) {
 				e.printStackTrace();
 			}			
 		}
+		
 		return true;
 	}
 	
 	@Override
-	protected String[] getArgs() {
+	protected String[] getArgs()
+	{
 		// TODO Auto-generated method stub
 		return null;
 	}
-	//this should be a generic method for any widget that is clicked while an item is being held
-	public boolean itemHeldWhileClicked(InteractiveWidget iw){
-			
+	
+	/**
+	 * This should be a generic method for any widget that is clicked while an item is being held.
+	 */
+	public boolean itemHeldWhileClicked(Widget iw)
+	{
 		ItemsLeftClickDropped();
-		return true;
-			
-	}
-	public boolean getdropInteractableStatus(){
+		
 		return true;
 	}
 	
+	public boolean getdropInteractableStatus()
+	{
+		return true;
+	}
 }
Index: /trunk/src/org/expeditee/items/widgets/SampleWidget2.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/SampleWidget2.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/SampleWidget2.java	(revision 1102)
@@ -19,6 +19,4 @@
 package org.expeditee.items.widgets;
 
-
-import java.awt.Color;
 import java.awt.FlowLayout;
 import java.awt.Font;
@@ -32,7 +30,9 @@
 import javax.swing.JToggleButton;
 
+import org.expeditee.core.Colour;
+import org.expeditee.gio.swing.SwingConversions;
 import org.expeditee.items.Text;
 
-public class SampleWidget2 extends InteractiveWidget {
+public class SampleWidget2 extends SwingWidget {
 	
 	private JComboBox _combo;
@@ -47,5 +47,5 @@
 		
 		JPanel p = new JPanel(new FlowLayout());
-		p.setBackground(new Color(255,228,195));
+		p.setBackground(SwingConversions.toSwingColor(Colour.FromRGB255(255,228,195)));
 
 		JLabel lbl = new JLabel("This is an example InteractiveWidget!");
Index: /trunk/src/org/expeditee/items/widgets/Undo.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/Undo.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/Undo.java	(revision 1102)
@@ -4,5 +4,5 @@
 import java.awt.event.ActionListener;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Text;
 
@@ -17,5 +17,5 @@
 	        public void actionPerformed(ActionEvent e) {
 	        		           
-	           DisplayIO.getCurrentFrame().undo();		     
+	           DisplayController.getCurrentFrame().undo();		     
 	        }          
 	     });		
Index: /trunk/src/org/expeditee/items/widgets/WidgetCacheManager.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/WidgetCacheManager.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/WidgetCacheManager.java	(revision 1102)
@@ -25,5 +25,5 @@
 import java.util.Set;
 
-import org.expeditee.gui.DisplayIOObserver;
+import org.expeditee.gui.DisplayObserver;
 import org.expeditee.gui.FrameIO;
 
@@ -37,5 +37,5 @@
  *
  */
-public final class WidgetCacheManager implements DisplayIOObserver {
+public final class WidgetCacheManager implements DisplayObserver {
 	
 	private static HashMap<HeavyDutyInteractiveWidget, Integer> transientWidgets = new HashMap<HeavyDutyInteractiveWidget, Integer>();
Index: /trunk/src/org/expeditee/items/widgets/WidgetCorner.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/WidgetCorner.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/WidgetCorner.java	(revision 1102)
@@ -19,9 +19,9 @@
 package org.expeditee.items.widgets;
 
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Polygon;
 import java.util.List;
 
+import org.expeditee.core.Colour;
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.PolygonBounds;
 import org.expeditee.items.Dot;
 import org.expeditee.items.ItemParentStateChangedEvent;
@@ -30,7 +30,7 @@
 public class WidgetCorner extends Dot {
 
-	private InteractiveWidget _widgetSource;
-
-	WidgetCorner(int x, int y, int id, InteractiveWidget widgetSource) {
+	private Widget _widgetSource;
+
+	WidgetCorner(int x, int y, int id, Widget widgetSource) {
 		super(x, y, id);
 
@@ -38,11 +38,4 @@
 			throw new NullPointerException("widgetSource");
 		_widgetSource = widgetSource;
-	}
-
-	@Override
-	public void updatePolygon() {
-		super.updatePolygon();
-		if (_widgetSource != null)
-			_widgetSource.onBoundsChanged();
 	}
 
@@ -81,28 +74,30 @@
 
 	@Override
-	public void onParentStateChanged(ItemParentStateChangedEvent e) {
+	public void onParentStateChanged(ItemParentStateChangedEvent e)
+	{
 		super.onParentStateChanged(e);
 		_widgetSource.onParentStateChanged(e);
 	}
 
-	public InteractiveWidget getWidgetSource() {
+	public Widget getWidgetSource() {
 		return _widgetSource;
 	}
 
 	@Override
-	public void paint(Graphics2D g) {
+	public void paint()
+	{
 		// For fixed widgets, always have corner selected with connected context
-		HighlightMode tmp = _mode; // save mode
-		if (_mode == HighlightMode.Normal && _widgetSource.isFixedSize()) {
-			_mode = HighlightMode.Connected; // draw as connected context for
+		HighlightMode tmp = _highlightMode; // save mode
+		if (_highlightMode == HighlightMode.Normal && _widgetSource.isFixedSize()) {
+			_highlightMode = HighlightMode.Connected; // draw as connected context for
 			// fixed widgets
 		}
-		super.paint(g);
-		_mode = tmp; // restore mode
-	}
-
-	@Override
-	public void paintFill(Graphics2D g) {
-		_widgetSource.paintFill(g); // only paints a fill if floating
+		super.paint();
+		_highlightMode = tmp; // restore mode
+	}
+
+	@Override
+	public void paintFill() {
+		_widgetSource.paintFill(); // only paints a fill if floating
 	}
 
@@ -127,5 +122,5 @@
 
 	@Override
-	public void setArrowhead(Polygon arrow) {
+	public void setArrowhead(PolygonBounds arrow) {
 	}
 
@@ -139,5 +134,5 @@
 
 	@Override
-	public void setBackgroundColor(Color c) {
+	public void setBackgroundColor(Colour c) {
 		if (_widgetSource != null) {
 			super.setBackgroundColor(c);
@@ -147,9 +142,9 @@
 
 	@Override
-	public void setBottomShadowColor(Color bottom) {
-	}
-
-	@Override
-	public void setFillColor(Color c) {
+	public void setBottomShadowColor(Colour bottom) {
+	}
+
+	@Override
+	public void setFillColor(Colour c) {
 	}
 
@@ -186,40 +181,38 @@
 	}
 
-	public void setAnchorCornerX(Float anchorLeft, Float anchorRight) {
-		_anchorLeft = anchorLeft;
-		_anchorRight = anchorRight;
-	}
-	
-	public void setAnchorCornerY(Float anchorTop, Float anchorBottom) {
-		_anchorTop = anchorTop;
-		_anchorBottom= anchorBottom;
-	}
-	
-	@Override
-	public void setAnchorLeft(Float anchor) {
+	public void setAnchorCornerX(Integer anchorLeft, Integer anchorRight)
+	{
+		_anchoring.setLeftAnchor(anchorLeft);
+		_anchoring.setRightAnchor(anchorRight);
+	}
+	
+	public void setAnchorCornerY(Integer anchorTop, Integer anchorBottom)
+	{
+		_anchoring.setTopAnchor(anchorTop);
+		_anchoring.setBottomAnchor(anchorBottom);
+	}
+	
+	@Override
+	public void setAnchorLeft(Integer anchor) {
 		_widgetSource.setAnchorLeft(anchor);
-		_anchorLeft = anchor;
-		_anchorRight = null;
-	}
-
-	@Override
-	public void setAnchorRight(Float anchor) {
+		_anchoring.setLeftAnchor(anchor);
+	}
+
+	@Override
+	public void setAnchorRight(Integer anchor) {
 		_widgetSource.setAnchorRight(anchor);
-		_anchorLeft = null;
-		_anchorRight = anchor;
-	}
-	
-	@Override
-	public void setAnchorTop(Float anchor) {
+		_anchoring.setRightAnchor(anchor);
+	}
+	
+	@Override
+	public void setAnchorTop(Integer anchor) {
 		_widgetSource.setAnchorTop(anchor);
-		_anchorTop = anchor;
-		_anchorBottom = null;
-	}
-
-	@Override
-	public void setAnchorBottom(Float anchor) {
+		_anchoring.setTopAnchor(anchor);
+	}
+
+	@Override
+	public void setAnchorBottom(Integer anchor) {
 		_widgetSource.setAnchorBottom(anchor);
-		_anchorTop = null;
-		_anchorBottom = anchor;
+		_anchoring.setBottomAnchor(anchor);
 	}
 	
@@ -251,7 +244,7 @@
 
 	@Override
-	public boolean contains(int x, int y) {
-		return super.contains(x, y)
-				&& !_widgetSource.getBounds().contains(x, y);
+	public boolean contains(Point p)
+	{
+		return super.contains(p) && !_widgetSource.getBounds().contains(p);
 	}
 
@@ -268,5 +261,5 @@
 
 	@Override
-	public void setColor(Color color) {
+	public void setColor(Colour color) {
 		if (_widgetSource != null) {
 			super.setColor(color);
